git-am.shon commit Merge branch 'dc/gitweb' (ee0d794)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5OPTIONS_KEEPDASHDASH=
   6OPTIONS_SPEC="\
   7git-am [options] <mbox>|<Maildir>...
   8git-am [options] --resolved
   9git-am [options] --skip
  10--
  11d,dotest=       use <dir> and not .dotest
  12i,interactive   run interactively
  13b,binary        pass --allo-binary-replacement to git-apply
  143,3way          allow fall back on 3way merging if needed
  15s,signoff       add a Signed-off-by line to the commit message
  16u,utf8          recode into utf8 (default)
  17k,keep          pass -k flagg to git-mailinfo
  18whitespace=     pass it through git-apply
  19C=              pass it through git-apply
  20p=              pass it through git-apply
  21resolvemsg=     override error message when patch failure occurs
  22r,resolved      to be used after a patch failure
  23skip            skip the current patch"
  24
  25. git-sh-setup
  26set_reflog_action am
  27require_work_tree
  28
  29git var GIT_COMMITTER_IDENT >/dev/null || exit
  30
  31stop_here () {
  32    echo "$1" >"$dotest/next"
  33    exit 1
  34}
  35
  36stop_here_user_resolve () {
  37    if [ -n "$resolvemsg" ]; then
  38            printf '%s\n' "$resolvemsg"
  39            stop_here $1
  40    fi
  41    cmdline=$(basename $0)
  42    if test '' != "$interactive"
  43    then
  44        cmdline="$cmdline -i"
  45    fi
  46    if test '' != "$threeway"
  47    then
  48        cmdline="$cmdline -3"
  49    fi
  50    if test '.dotest' != "$dotest"
  51    then
  52        cmdline="$cmdline -d=$dotest"
  53    fi
  54    echo "When you have resolved this problem run \"$cmdline --resolved\"."
  55    echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
  56
  57    stop_here $1
  58}
  59
  60go_next () {
  61        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
  62                "$dotest/patch" "$dotest/info"
  63        echo "$next" >"$dotest/next"
  64        this=$next
  65}
  66
  67cannot_fallback () {
  68        echo "$1"
  69        echo "Cannot fall back to three-way merge."
  70        exit 1
  71}
  72
  73fall_back_3way () {
  74    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
  75
  76    rm -fr "$dotest"/patch-merge-*
  77    mkdir "$dotest/patch-merge-tmp-dir"
  78
  79    # First see if the patch records the index info that we can use.
  80    git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
  81        "$dotest/patch" &&
  82    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
  83    git write-tree >"$dotest/patch-merge-base+" ||
  84    cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
  85
  86    echo Using index info to reconstruct a base tree...
  87    if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
  88        git apply $binary --cached <"$dotest/patch"
  89    then
  90        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
  91        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
  92    else
  93        cannot_fallback "Did you hand edit your patch?
  94It does not apply to blobs recorded in its index."
  95    fi
  96
  97    test -f "$dotest/patch-merge-index" &&
  98    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
  99    orig_tree=$(cat "$dotest/patch-merge-base") &&
 100    rm -fr "$dotest"/patch-merge-* || exit 1
 101
 102    echo Falling back to patching base and 3-way merge...
 103
 104    # This is not so wrong.  Depending on which base we picked,
 105    # orig_tree may be wildly different from ours, but his_tree
 106    # has the same set of wildly different changes in parts the
 107    # patch did not touch, so recursive ends up canceling them,
 108    # saying that we reverted all those changes.
 109
 110    eval GITHEAD_$his_tree='"$SUBJECT"'
 111    export GITHEAD_$his_tree
 112    git-merge-recursive $orig_tree -- HEAD $his_tree || {
 113            git rerere
 114            echo Failed to merge in the changes.
 115            exit 1
 116    }
 117    unset GITHEAD_$his_tree
 118}
 119
 120prec=4
 121dotest=.dotest sign= utf8=t keep= skip= interactive= resolved= binary=
 122resolvemsg= resume=
 123git_apply_opt=
 124
 125while test $# != 0
 126do
 127        case "$1" in
 128        -i|--interactive)
 129                interactive=t ;;
 130        -b|--binary)
 131                binary=t ;;
 132        -3|--3way)
 133                threeway=t ;;
 134        -s|--signoff)
 135                sign=t ;;
 136        -u|--utf8)
 137                utf8=t ;; # this is now default
 138        --no-utf8)
 139                utf8= ;;
 140        -k|--keep)
 141                keep=t ;;
 142        -r|--resolved)
 143                resolved=t ;;
 144        --skip)
 145                skip=t ;;
 146        -d|--dotest)
 147                shift; dotest=$1;;
 148        --resolvemsg)
 149                shift; resolvemsg=$1 ;;
 150        --whitespace)
 151                git_apply_opt="$git_apply_opt $1=$2"; shift ;;
 152        -C|-p)
 153                git_apply_opt="$git_apply_opt $1$2"; shift ;;
 154        --)
 155                shift; break ;;
 156        *)
 157                usage ;;
 158        esac
 159        shift
 160done
 161
 162# If the dotest directory exists, but we have finished applying all the
 163# patches in them, clear it out.
 164if test -d "$dotest" &&
 165   last=$(cat "$dotest/last") &&
 166   next=$(cat "$dotest/next") &&
 167   test $# != 0 &&
 168   test "$next" -gt "$last"
 169then
 170   rm -fr "$dotest"
 171fi
 172
 173if test -d "$dotest"
 174then
 175        case "$#,$skip$resolved" in
 176        0,*t*)
 177                # Explicit resume command and we do not have file, so
 178                # we are happy.
 179                : ;;
 180        0,)
 181                # No file input but without resume parameters; catch
 182                # user error to feed us a patch from standard input
 183                # when there is already .dotest.  This is somewhat
 184                # unreliable -- stdin could be /dev/null for example
 185                # and the caller did not intend to feed us a patch but
 186                # wanted to continue unattended.
 187                tty -s
 188                ;;
 189        *)
 190                false
 191                ;;
 192        esac ||
 193        die "previous dotest directory $dotest still exists but mbox given."
 194        resume=yes
 195else
 196        # Make sure we are not given --skip nor --resolved
 197        test ",$skip,$resolved," = ,,, ||
 198                die "Resolve operation not in progress, we are not resuming."
 199
 200        # Start afresh.
 201        mkdir -p "$dotest" || exit
 202
 203        git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
 204                rm -fr "$dotest"
 205                exit 1
 206        }
 207
 208        # -b, -s, -u, -k and --whitespace flags are kept for the
 209        # resuming session after a patch failure.
 210        # -3 and -i can and must be given when resuming.
 211        echo "$binary" >"$dotest/binary"
 212        echo " $ws" >"$dotest/whitespace"
 213        echo "$sign" >"$dotest/sign"
 214        echo "$utf8" >"$dotest/utf8"
 215        echo "$keep" >"$dotest/keep"
 216        echo 1 >"$dotest/next"
 217fi
 218
 219case "$resolved" in
 220'')
 221        files=$(git diff-index --cached --name-only HEAD --) || exit
 222        if [ "$files" ]; then
 223           echo "Dirty index: cannot apply patches (dirty: $files)" >&2
 224           exit 1
 225        fi
 226esac
 227
 228if test "$(cat "$dotest/binary")" = t
 229then
 230        binary=--allow-binary-replacement
 231fi
 232if test "$(cat "$dotest/utf8")" = t
 233then
 234        utf8=-u
 235else
 236        utf8=-n
 237fi
 238if test "$(cat "$dotest/keep")" = t
 239then
 240        keep=-k
 241fi
 242ws=`cat "$dotest/whitespace"`
 243if test "$(cat "$dotest/sign")" = t
 244then
 245        SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
 246                        s/>.*/>/
 247                        s/^/Signed-off-by: /'
 248                `
 249else
 250        SIGNOFF=
 251fi
 252
 253last=`cat "$dotest/last"`
 254this=`cat "$dotest/next"`
 255if test "$skip" = t
 256then
 257        git rerere clear
 258        this=`expr "$this" + 1`
 259        resume=
 260fi
 261
 262if test "$this" -gt "$last"
 263then
 264        echo Nothing to do.
 265        rm -fr "$dotest"
 266        exit
 267fi
 268
 269while test "$this" -le "$last"
 270do
 271        msgnum=`printf "%0${prec}d" $this`
 272        next=`expr "$this" + 1`
 273        test -f "$dotest/$msgnum" || {
 274                resume=
 275                go_next
 276                continue
 277        }
 278
 279        # If we are not resuming, parse and extract the patch information
 280        # into separate files:
 281        #  - info records the authorship and title
 282        #  - msg is the rest of commit log message
 283        #  - patch is the patch body.
 284        #
 285        # When we are resuming, these files are either already prepared
 286        # by the user, or the user can tell us to do so by --resolved flag.
 287        case "$resume" in
 288        '')
 289                git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
 290                        <"$dotest/$msgnum" >"$dotest/info" ||
 291                        stop_here $this
 292
 293                # skip pine's internal folder data
 294                grep '^Author: Mail System Internal Data$' \
 295                        <"$dotest"/info >/dev/null &&
 296                        go_next && continue
 297
 298                test -s $dotest/patch || {
 299                        echo "Patch is empty.  Was it split wrong?"
 300                        stop_here $this
 301                }
 302                git stripspace < "$dotest/msg" > "$dotest/msg-clean"
 303                ;;
 304        esac
 305
 306        GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 307        GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 308        GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 309
 310        if test -z "$GIT_AUTHOR_EMAIL" || test -z "$GIT_AUTHOR_DATE"
 311        then
 312                echo "Patch does not have valid authorship information."
 313                stop_here $this
 314        fi
 315
 316        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 317
 318        SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
 319        case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
 320
 321        case "$resume" in
 322        '')
 323            if test '' != "$SIGNOFF"
 324            then
 325                LAST_SIGNED_OFF_BY=`
 326                    sed -ne '/^Signed-off-by: /p' \
 327                    "$dotest/msg-clean" |
 328                    tail -n 1
 329                `
 330                ADD_SIGNOFF=`
 331                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 332                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 333                    echo "$SIGNOFF"
 334                }`
 335            else
 336                ADD_SIGNOFF=
 337            fi
 338            {
 339                printf '%s\n' "$SUBJECT"
 340                if test -s "$dotest/msg-clean"
 341                then
 342                        echo
 343                        cat "$dotest/msg-clean"
 344                fi
 345                if test '' != "$ADD_SIGNOFF"
 346                then
 347                        echo "$ADD_SIGNOFF"
 348                fi
 349            } >"$dotest/final-commit"
 350            ;;
 351        *)
 352                case "$resolved$interactive" in
 353                tt)
 354                        # This is used only for interactive view option.
 355                        git diff-index -p --cached HEAD -- >"$dotest/patch"
 356                        ;;
 357                esac
 358        esac
 359
 360        resume=
 361        if test "$interactive" = t
 362        then
 363            test -t 0 ||
 364            die "cannot be interactive without stdin connected to a terminal."
 365            action=again
 366            while test "$action" = again
 367            do
 368                echo "Commit Body is:"
 369                echo "--------------------------"
 370                cat "$dotest/final-commit"
 371                echo "--------------------------"
 372                printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 373                read reply
 374                case "$reply" in
 375                [yY]*) action=yes ;;
 376                [aA]*) action=yes interactive= ;;
 377                [nN]*) action=skip ;;
 378                [eE]*) git_editor "$dotest/final-commit"
 379                       action=again ;;
 380                [vV]*) action=again
 381                       LESS=-S ${PAGER:-less} "$dotest/patch" ;;
 382                *)     action=again ;;
 383                esac
 384            done
 385        else
 386            action=yes
 387        fi
 388
 389        if test $action = skip
 390        then
 391                go_next
 392                continue
 393        fi
 394
 395        if test -x "$GIT_DIR"/hooks/applypatch-msg
 396        then
 397                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 398                stop_here $this
 399        fi
 400
 401        printf 'Applying %s\n' "$SUBJECT"
 402
 403        case "$resolved" in
 404        '')
 405                git apply $git_apply_opt $binary --index "$dotest/patch"
 406                apply_status=$?
 407                ;;
 408        t)
 409                # Resolved means the user did all the hard work, and
 410                # we do not have to do any patch application.  Just
 411                # trust what the user has in the index file and the
 412                # working tree.
 413                resolved=
 414                git diff-index --quiet --cached HEAD -- && {
 415                        echo "No changes - did you forget to use 'git add'?"
 416                        stop_here_user_resolve $this
 417                }
 418                unmerged=$(git ls-files -u)
 419                if test -n "$unmerged"
 420                then
 421                        echo "You still have unmerged paths in your index"
 422                        echo "did you forget to use 'git add'?"
 423                        stop_here_user_resolve $this
 424                fi
 425                apply_status=0
 426                git rerere
 427                ;;
 428        esac
 429
 430        if test $apply_status = 1 && test "$threeway" = t
 431        then
 432                if (fall_back_3way)
 433                then
 434                    # Applying the patch to an earlier tree and merging the
 435                    # result may have produced the same tree as ours.
 436                    git diff-index --quiet --cached HEAD -- && {
 437                        echo No changes -- Patch already applied.
 438                        go_next
 439                        continue
 440                    }
 441                    # clear apply_status -- we have successfully merged.
 442                    apply_status=0
 443                fi
 444        fi
 445        if test $apply_status != 0
 446        then
 447                echo Patch failed at $msgnum.
 448                stop_here_user_resolve $this
 449        fi
 450
 451        if test -x "$GIT_DIR"/hooks/pre-applypatch
 452        then
 453                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 454        fi
 455
 456        tree=$(git write-tree) &&
 457        parent=$(git rev-parse --verify HEAD) &&
 458        commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
 459        git update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
 460        stop_here $this
 461
 462        if test -x "$GIT_DIR"/hooks/post-applypatch
 463        then
 464                "$GIT_DIR"/hooks/post-applypatch
 465        fi
 466
 467        git gc --auto
 468
 469        go_next
 470done
 471
 472rm -fr "$dotest"